#include <stdio.h>
#include <stdlib.h>
#include "browse.h"
#include "struct.h"

#define MAX_LEN_SBOX 25
#define REAL_SMALL 1.e-6
#define MAX_LEN_SBOX 25
#define MAXBIFCRV 100
#define max(a,b) ((a>b) ? a : b)

extern GRAPH *MyGraph;
extern char uvar_names[MAXODE][12];
extern int PS_FONTSIZE;
extern int storind;

int colorline[] = { 0, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 0 };
int CurrentCurve = 0;

extern double T0, TEND;

typedef struct
{
  char angle[20];
  char yes[3];
  double start;
  double incr;
  int nclip;
} MOV3D;

MOV3D mov3d = { "theta", "N", 45, 45, 7 };


change_view_com (int com)
{
  int got_new_view = 0;
  if (com == 2)
    {
      make_my_aplot ("Array!");
      edit_aplot ();
      return;
    }
  if (com == 3)
    {
      new_vcr ();
      return;
    }

  if (com == 0)
    got_new_view = get_2d_view (CurrentCurve);
  else
    got_new_view = get_3d_view (CurrentCurve);

  if (got_new_view)
    MyGraph->grtype = 5 * com;

/*
  MyGraph->grtype = 5 * com;
  if (MyGraph->grtype < 5)
    get_2d_view (CurrentCurve);
  else
    get_3d_view (CurrentCurve);
*/

  check_flags ();
  get_draw_area ();
  redraw_the_graph ();

}

ind_to_sym (ind, str)
     char *str;
     int ind;
{
  if (ind == 0)
    strcpy (str, "T");
  else
    strcpy (str, uvar_names[ind - 1]);
}

check_flags ()
{
  if (MyGraph->grtype > 4)
    MyGraph->ThreeDFlag = 1;
  else
    MyGraph->ThreeDFlag = 0;
  if ((MyGraph->xv[0] == 0) || (MyGraph->yv[0] == 0) ||
      ((MyGraph->zv[0] == 0) && (MyGraph->ThreeDFlag == 1)))
    MyGraph->TimeFlag = 1;
  else
    MyGraph->TimeFlag = 0;

}


int
get_2d_view (ind)
     int ind;
{
  static char *n[] = { "*0X-axis", "*0Y-axis", "Xmin", "Ymin",
    "Xmax", "Ymax", "Xlabel", "Ylabel"
  };
  char values[8][MAX_LEN_SBOX];
  int status, i;
  int i1 = MyGraph->xv[ind], i2 = MyGraph->yv[ind];
  char n1[15], n2[15];
  ind_to_sym (i1, n1);
  ind_to_sym (i2, n2);
  sprintf (values[0], "%s", n1);
  sprintf (values[1], "%s", n2);
  sprintf (values[2], "%g", MyGraph->xmin);
  sprintf (values[3], "%g", MyGraph->ymin);
  sprintf (values[4], "%g", MyGraph->xmax);
  sprintf (values[5], "%g", MyGraph->ymax);
  sprintf (values[6], "%s", MyGraph->xlabel);
  sprintf (values[7], "%s", MyGraph->ylabel);
  status = do_string_box (8, 4, 2, "2D View", n, values, 31);
  if (status != 0)
    {
      MyGraph->ThreeDFlag = 0;
      /*  get variable names  */
      find_variable (values[0], &i);
      if (i > -1)
	MyGraph->xv[ind] = i;
      find_variable (values[1], &i);
      if (i > -1)
	MyGraph->yv[ind] = i;

      MyGraph->xmin = atof (values[2]);
      MyGraph->ymin = atof (values[3]);
      MyGraph->xmax = atof (values[4]);
      MyGraph->ymax = atof (values[5]);
      MyGraph->xlo = MyGraph->xmin;
      MyGraph->ylo = MyGraph->ymin;
      MyGraph->xhi = MyGraph->xmax;
      MyGraph->yhi = MyGraph->ymax;
      sprintf (MyGraph->xlabel, "%s", values[6]);
      sprintf (MyGraph->ylabel, "%s", values[7]);
      check_windows ();
      return 1;
    }
  return 0;
}


axes_opts ()
{
  static char *n[] = { "X-origin", "Y-origin", "Z-origin",
    "X-org(1=on)", "Y-org(1=on)", "Z-org(1=on",
    "PSFontSize"
  };
  char values[7][MAX_LEN_SBOX];
  int status;
  sprintf (values[0], "%g", MyGraph->xorg);
  sprintf (values[1], "%g", MyGraph->yorg);
  sprintf (values[2], "%g", MyGraph->zorg);
  sprintf (values[3], "%d", MyGraph->xorgflag);
  sprintf (values[4], "%d", MyGraph->yorgflag);
  sprintf (values[5], "%d", MyGraph->zorgflag);
  sprintf (values[6], "%d", PS_FONTSIZE);
  status = do_string_box (7, 7, 1, "Axes options", n, values, 25);
  if (status != 0)
    {
      MyGraph->xorg = atof (values[0]);
      MyGraph->yorg = atof (values[1]);
      MyGraph->zorg = atof (values[2]);
      MyGraph->xorgflag = atoi (values[3]);
      MyGraph->yorgflag = atoi (values[4]);
      MyGraph->zorgflag = atoi (values[5]);
      PS_FONTSIZE = atoi (values[6]);
      redraw_the_graph ();
    }
}

int
get_3d_view (ind)
     int ind;
{
  static char *n[] = { "*0X-axis", "*0Y-axis", "*0Z-axis",
    "Xmin", "Xmax", "Ymin",
    "Ymax", "Zmin", "Zmax",
    "XLo", "XHi", "YLo", "YHi", "Xlabel", "Ylabel", "Zlabel"
  };
  char values[16][MAX_LEN_SBOX];
  int status, i, i1 = MyGraph->xv[ind], i2 = MyGraph->yv[ind], i3 =
    MyGraph->zv[ind];
  char n1[15], n2[15], n3[15];
  ind_to_sym (i1, n1);
  ind_to_sym (i2, n2);
  ind_to_sym (i3, n3);
  sprintf (values[0], "%s", n1);
  sprintf (values[1], "%s", n2);
  sprintf (values[2], "%s", n3);
  sprintf (values[3], "%g", MyGraph->xmin);
  sprintf (values[5], "%g", MyGraph->ymin);
  sprintf (values[7], "%g", MyGraph->zmin);
  sprintf (values[4], "%g", MyGraph->xmax);
  sprintf (values[6], "%g", MyGraph->ymax);
  sprintf (values[8], "%g", MyGraph->zmax);

  if (MyGraph->ThreeDFlag)
    {
      sprintf (values[9], "%g", MyGraph->xlo);
      sprintf (values[11], "%g", MyGraph->ylo);
      sprintf (values[10], "%g", MyGraph->xhi);
      sprintf (values[12], "%g", MyGraph->yhi);
    }
  else
    {
      /* if changing from 2D->3D, give nice defaults */
      sprintf (values[9], "%s", "-1.5");
      sprintf (values[11], "%s", "-2");
      sprintf (values[10], "%s", "1.5");
      sprintf (values[12], "%s", "2");
    }

  sprintf (values[13], "%s", MyGraph->xlabel);
  sprintf (values[14], "%s", MyGraph->ylabel);
  sprintf (values[15], "%s", MyGraph->zlabel);
  status = do_string_box (16, 6, 3, "3D View", n, values, 31);
  if (status != 0)
    {
      MyGraph->ThreeDFlag = 1;
      /*  get variable names  */
      find_variable (values[0], &i);
      if (i > -1)
	MyGraph->xv[ind] = i;
      find_variable (values[1], &i);
      if (i > -1)
	MyGraph->yv[ind] = i;
      find_variable (values[2], &i);
      if (i > -1)
	MyGraph->zv[ind] = i;
      sprintf (MyGraph->xlabel, "%s", values[13]);
      sprintf (MyGraph->ylabel, "%s", values[14]);
      sprintf (MyGraph->zlabel, "%s", values[15]);


      MyGraph->xmin = atof (values[3]);
      MyGraph->ymin = atof (values[5]);
      MyGraph->zmin = atof (values[7]);
      MyGraph->xmax = atof (values[4]);
      MyGraph->ymax = atof (values[6]);
      MyGraph->zmax = atof (values[8]);
      MyGraph->xlo = atof (values[9]);
      MyGraph->ylo = atof (values[11]);
      MyGraph->xhi = atof (values[10]);
      MyGraph->yhi = atof (values[12]);
      check_windows ();
      /*      printf("%f %f %f %f %f %f \n %f %f %f %f",
         MyGraph->xmin,MyGraph->xmax,
         MyGraph->ymin,MyGraph->ymax,
         MyGraph->zmin,MyGraph->zmax,
         MyGraph->xlo,MyGraph->xhi,
         MyGraph->ylo,MyGraph->yhi);
       */
      return 1;
    }
  return 0;
}


check_val (x1, x2, xb, xd)
     double *x1, *x2, *xb, *xd;
{
  double temp;

/* 
  see get_max for details
*/

  if (*x1 == *x2)
    {
      temp = .05 * max (fabs (*x1), 1.0);
      *x1 = *x1 - temp;
      *x2 = *x2 + temp;
    }
  if (*x1 > *x2)
    {
      temp = *x2;
      *x2 = *x1;
      *x1 = temp;

    }
  *xb = .5 * (*x1 + *x2);
  *xd = 2.0 / (*x2 - *x1);
}


get_max (index, vmin, vmax)
     double *vmax, *vmin;
     int index;
{
  float x0, x1, z;
  double temp;
  int i;
  x0 = my_browser.data[index][0];
  x1 = x0;
  for (i = 0; i < my_browser.maxrow; i++)
    {
      z = my_browser.data[index][i];
      if (z < x0)
	x0 = z;
      if (z > x1)
	x1 = z;
    }
  *vmin = (double) x0;
  *vmax = (double) x1;
  if (fabs (*vmin - *vmax) < REAL_SMALL)
    {
      temp = .05 * max (fabs (*vmin), 1.0);
      *vmin = *vmin - temp;
      *vmax = *vmax + temp;
    }


}

pretty (x1, x2)			/* this was always pretty ugly */
     double *x1, *x2;
{
/* if(fabs(*x1-*x2)<1.e-12)
 *x2=*x1+max(.1*fabs(*x2),1.0); */
}

corner_cube (xlo, xhi, ylo, yhi)
     double *xlo, *ylo, *xhi, *yhi;
{
  float x, y;
  float x1, x2, y1, y2;
  threedproj (-1., -1., -1., &x, &y);
  x1 = x;
  x2 = x;
  y1 = y;
  y2 = y;
  threedproj (-1., -1., 1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (-1., 1., -1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (-1., 1., 1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (1., -1., -1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (1., -1., 1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (1., 1., 1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  threedproj (1., 1., -1., &x, &y);
  if (x < x1)
    x1 = x;
  if (x > x2)
    x2 = x;
  if (y < y1)
    y1 = y;
  if (y > y2)
    y2 = y;
  *xlo = x1;
  *ylo = y1;
  *xhi = x2;
  *yhi = y2;
}






fit_window ()
{
  double Mx = -1.e25, My = -1.e25, Mz = -1.e25, mx = -Mx, my = -My, mz = -Mz;
  int i, n = MyGraph->nvars;
  if (storind < 2)
    return;
  if (MyGraph->ThreeDFlag)
    {
      for (i = 0; i < n; i++)
	{

	  get_max (MyGraph->xv[i], &(MyGraph->xmin), &(MyGraph->xmax));
	  Mx = max (MyGraph->xmax, Mx);
	  mx = -max (-MyGraph->xmin, -mx);

	  get_max (MyGraph->yv[i], &(MyGraph->ymin), &(MyGraph->ymax));
	  My = max (MyGraph->ymax, My);
	  my = -max (-MyGraph->ymin, -my);

	  get_max (MyGraph->zv[i], &(MyGraph->zmin), &(MyGraph->zmax));
	  Mz = max (MyGraph->zmax, Mz);
	  mz = -max (-MyGraph->zmin, -mz);

	}
      MyGraph->xmax = Mx;
      MyGraph->ymax = My;
      MyGraph->zmax = Mz;
      MyGraph->xmin = mx;
      MyGraph->ymin = my;
      MyGraph->zmin = mz;


      pretty (&(MyGraph->ymin), &(MyGraph->ymax));
      pretty (&(MyGraph->xmin), &(MyGraph->xmax));
      pretty (&(MyGraph->zmin), &(MyGraph->zmax));
      corner_cube (&(MyGraph->xlo), &(MyGraph->xhi), &(MyGraph->ylo),
		   &(MyGraph->yhi));
      pretty (&(MyGraph->xlo), &(MyGraph->xhi));
      pretty (&(MyGraph->ylo), &(MyGraph->yhi));
      check_windows ();
    }
  else
    {
      for (i = 0; i < n; i++)
	{
	  get_max (MyGraph->xv[i], &(MyGraph->xmin), &(MyGraph->xmax));
	  Mx = max (MyGraph->xmax, Mx);
	  mx = -max (-MyGraph->xmin, -mx);

	  get_max (MyGraph->yv[i], &(MyGraph->ymin), &(MyGraph->ymax));
	  My = max (MyGraph->ymax, My);
	  my = -max (-MyGraph->ymin, -my);

	}
      MyGraph->xmax = Mx;
      MyGraph->ymax = My;

      MyGraph->xmin = mx;
      MyGraph->ymin = my;


      pretty (&(MyGraph->ymin), &(MyGraph->ymax));
      pretty (&(MyGraph->xmin), &(MyGraph->xmax));
      MyGraph->xlo = MyGraph->xmin;
      MyGraph->ylo = MyGraph->ymin;
      MyGraph->xhi = MyGraph->xmax;
      MyGraph->yhi = MyGraph->ymax;
      check_windows ();
    }
  redraw_the_graph ();

}







check_windows ()
{
  double zip, zap;
  check_val (&MyGraph->xmin, &MyGraph->xmax, &MyGraph->xbar, &MyGraph->dx);
  check_val (&MyGraph->ymin, &MyGraph->ymax, &MyGraph->ybar, &MyGraph->dy);
  check_val (&MyGraph->zmin, &MyGraph->zmax, &MyGraph->zbar, &MyGraph->dz);
  check_val (&MyGraph->xlo, &MyGraph->xhi, &zip, &zap);
  check_val (&MyGraph->ylo, &MyGraph->yhi, &zip, &zap);
}

user_window ()
{
  static char *n[] = { "X Lo", "X Hi", "Y Lo", "Y Hi" };
  char values[4][MAX_LEN_SBOX];
  int status;
  sprintf (values[0], "%g", MyGraph->xlo);
  sprintf (values[2], "%g", MyGraph->ylo);
  sprintf (values[1], "%g", MyGraph->xhi);
  sprintf (values[3], "%g", MyGraph->yhi);
  status = do_string_box (4, 2, 2, "Window", n, values, 28);
  if (status != 0)
    {

      MyGraph->xlo = atof (values[0]);
      MyGraph->ylo = atof (values[2]);
      MyGraph->xhi = atof (values[1]);
      MyGraph->yhi = atof (values[3]);
      if (MyGraph->grtype < 5)
	{
	  MyGraph->xmin = MyGraph->xlo;
	  MyGraph->xmax = MyGraph->xhi;
	  MyGraph->ymin = MyGraph->ylo;
	  MyGraph->ymax = MyGraph->yhi;
	}
      check_windows ();
    }
  redraw_the_graph ();

}

xi_vs_t ()			/*  a short cut   */
{
  char name[20], value[20];
  int i = MyGraph->yv[0];


  ind_to_sym (i, value);
  sprintf (name, "Plot vs t: ");
  if (new_string (name, value))
    {
      find_variable (value, &i);

      if (i > -1)
	{
	  MyGraph->yv[0] = i;
	  MyGraph->grtype = 0;
	  MyGraph->xv[0] = 0;
	  if (storind >= 2)
	    {
	      get_max (MyGraph->xv[0], &(MyGraph->xmin), &(MyGraph->xmax));
	      pretty (&(MyGraph->xmin), &(MyGraph->xmax));
	      get_max (MyGraph->yv[0], &(MyGraph->ymin), &(MyGraph->ymax));
	      pretty (&(MyGraph->ymin), &(MyGraph->ymax));

	    }
	  else
	    {
	      MyGraph->xmin = T0;
	      MyGraph->xmax = TEND;
	    }
	  MyGraph->xlo = MyGraph->xmin;
	  MyGraph->ylo = MyGraph->ymin;
	  MyGraph->xhi = MyGraph->xmax;
	  MyGraph->yhi = MyGraph->ymax;
	  check_windows ();
	  check_flags ();
	  set_normal_scale ();
	  redraw_the_graph ();
	}
    }
}





redraw_the_graph ()
{
  MyGraph->numLines = MyGraph->numPoints = MyGraph->numTexts = 0;
  MyGraph->numRects = MyGraph->numFArcs = 0;
//  blank_screen (draw_win);
  set_normal_scale ();
  do_axes ();
//  hi_lite (draw_win);
  restore (0, my_browser.maxrow);
//  draw_label (draw_win);
//  draw_freeze (draw_win);
  redraw_dfield ();
  if (MyGraph->Nullrestore)
  {
    restore_nullclines ();
  }
}

redraw_graph_noerase ()
{
//  MyGraph->numLines = MyGraph->numPoints = MyGraph->numTexts = 0;
//  blank_screen (draw_win);
  set_normal_scale ();
  do_axes ();
//  hi_lite (draw_win);
  restore (0, my_browser.maxrow);
//  draw_label (draw_win);
//  draw_freeze (draw_win);
  redraw_dfield ();
  if (MyGraph->Nullrestore)
    restore_nullclines ();
}

movie_rot (start, increment, nclip, angle)
     int nclip, angle;
     double start, increment;
{
  int i;
  double thetaold = MyGraph->Theta, phiold = MyGraph->Phi;
  reset_film ();
  for (i = 0; i <= nclip; i++)
    {

      if (angle == 0)
	make_rot (start + i * increment, phiold);
      else
	make_rot (thetaold, start + i * increment);
      redraw_the_graph ();
      film_clip ();
    }
  MyGraph->Theta = thetaold;
  MyGraph->Phi = phiold;
}

test_rot ()
{
/*
 int done=0;
 int kp;
 XEvent ev;
 double theta=MyGraph->Theta,phi=MyGraph->Phi;
 redraw_cube(theta,phi);
 while(done==0){
    XNextEvent(display,&ev);
   if(ev.type==KeyPress){
      kp=get_key_press(&ev);
      switch(kp){
      case UP:
        phi=phi+1;
        redraw_cube(theta,phi);
        break;
      case DOWN:
	phi=phi-1;
        redraw_cube(theta,phi);
        break;
      case LEFT:
	theta=theta+1;
        redraw_cube(theta,phi);
        break;
      case RIGHT:
	theta=theta-1;
        redraw_cube(theta,phi);
        break;
      case FINE:
       done=1;
       break;
      case ESC:
       done=-1;
       break;
      }
   }
 }
 if(done==1){
   MyGraph->Phi=phi;
   MyGraph->Theta=theta;
 }
 redraw_the_graph();
   
*/
}

get_3d_par_com ()
{

  static char *n[] =
    { "Persp (1=On)", "ZPlane", "ZView", "Theta", "Phi", "Movie(Y/N)",
    "Vary (theta/phi)", "Start angle", "Increment",
    "Number increments"
  };
  char values[10][MAX_LEN_SBOX], anglename[20], ch;
  int status;
  //Window temp=main_win;
  int nclip = 8, angle = 0;
  double start, increment = 45;
  if (MyGraph->grtype < 5)
    return;


  sprintf (values[0], "%d", MyGraph->PerspFlag);
  sprintf (values[1], "%g", MyGraph->ZPlane);
  sprintf (values[2], "%g", MyGraph->ZView);
  sprintf (values[3], "%g", MyGraph->Theta);
  sprintf (values[4], "%g", MyGraph->Phi);
  sprintf (values[5], "%s", mov3d.yes);
  sprintf (values[6], "%s", mov3d.angle);
  sprintf (values[7], "%g", mov3d.start);
  sprintf (values[8], "%g", mov3d.incr);
  sprintf (values[9], "%d", mov3d.nclip);

  status = do_string_box (10, 5, 2, "3D Parameters", n, values, 28);
  if (status != 0)
    {
      MyGraph->PerspFlag = atoi (values[0]);
      MyGraph->ZPlane = atof (values[1]);
      MyGraph->ZView = atof (values[2]);
      MyGraph->Theta = atof (values[3]);
      MyGraph->Phi = atof (values[4]);
      if (values[5][0] == 'y' || values[5][0] == 'Y')
	{
	  strcpy (mov3d.yes, values[5]);
	  strcpy (mov3d.angle, values[6]);
	  start = atof (values[7]);
	  increment = atof (values[8]);
	  nclip = atoi (values[9]);
	  mov3d.start = start;
	  mov3d.incr = increment;
	  mov3d.nclip = nclip;
	  angle = 0;
	  if (mov3d.angle[0] == 'p' || mov3d.angle[0] == 'P')
	    angle = 1;
	  /*     XRaiseWindow(display,MyGraph->w); */
	  movie_rot (start, increment, nclip, angle);
	}

      make_rot (MyGraph->Theta, MyGraph->Phi);
      /*  Redraw the picture   */
      redraw_the_graph ();

    }

}


get_3d_par_noper ()
{

  static char *n[] = { "Theta", "Phi", "Movie(Y/N)",
    "Vary (theta/phi)", "Start angle", "Increment",
    "Number increments"
  };
  char values[10][MAX_LEN_SBOX], anglename[20], ch;
  int status;
// Window temp=main_win;
  int nclip = 8, angle = 0;
  double start, increment = 45;
  if (MyGraph->grtype < 5)
    return;


  sprintf (values[0], "%g", MyGraph->Theta);
  sprintf (values[1], "%g", MyGraph->Phi);
  sprintf (values[2], "%s", mov3d.yes);
  sprintf (values[3], "%s", mov3d.angle);
  sprintf (values[4], "%g", mov3d.start);
  sprintf (values[5], "%g", mov3d.incr);
  sprintf (values[6], "%d", mov3d.nclip);

  status = do_string_box (7, 7, 1, "3D Parameters", n, values, 28);
  if (status != 0)
    {
      /* MyGraph->PerspFlag=atoi(values[0]);
         MyGraph->ZPlane=atof(values[1]);
         MyGraph->ZView=atof(values[2]); */
      MyGraph->Theta = atof (values[0]);
      MyGraph->Phi = atof (values[1]);
      if (values[2][0] == 'y' || values[2][0] == 'Y')
	{
	  strcpy (mov3d.yes, values[2]);
	  strcpy (mov3d.angle, values[3]);
	  start = atof (values[4]);
	  increment = atof (values[5]);
	  nclip = atoi (values[6]);
	  mov3d.start = start;
	  mov3d.incr = increment;
	  mov3d.nclip = nclip;
	  angle = 0;
	  if (mov3d.angle[0] == 'p' || mov3d.angle[0] == 'P')
	    angle = 1;
	  /*     XRaiseWindow(display,MyGraph->w); */
	  movie_rot (start, increment, nclip, angle);
	}

      make_rot (MyGraph->Theta, MyGraph->Phi);
      /*  Redraw the picture   */
      redraw_the_graph ();

    }

}


window_zoom_com (int c)
{
  int i1, i2, j1, j2;
  switch (c)
    {
    case 0:
      user_window ();
      break;
    case 1:
      if (rubber (&i1, &j1, &i2, &j2) == 0)
        break;
      zoom_in (i1, j1, i2, j2);
      break;
    case 2:
      if (rubber (&i1, &j1, &i2, &j2) == 0)
        break;
      zoom_out (i1, j1, i2, j2);
      break;
    case 3:
      fit_window ();
      break;
    }
  set_normal_scale ();
}



zoom_in (i1, j1, i2, j2)
     int i1, j1, i2, j2;
{
  float x1, y1, x2, y2;
  scale_to_real (i1, j1, &x1, &y1);
  scale_to_real (i2, j2, &x2, &y2);

  MyGraph->xlo = x1;
  MyGraph->ylo = y1;
  MyGraph->xhi = x2;
  MyGraph->yhi = y2;
  if (MyGraph->grtype < 5)
    {
      MyGraph->xmin = MyGraph->xlo;
      MyGraph->xmax = MyGraph->xhi;
      MyGraph->ymin = MyGraph->ylo;
      MyGraph->ymax = MyGraph->yhi;
    }
  check_windows ();
  redraw_the_graph ();
//  draw_help ();
}

zoom_out (i1, j1, i2, j2)
{
  float x1, y1, x2, y2;
  float bx, mux, by, muy;
  float dx = MyGraph->xhi - MyGraph->xlo;
  float dy = MyGraph->yhi - MyGraph->ylo;
  scale_to_real (i1, j1, &x1, &y1);
  scale_to_real (i2, j2, &x2, &y2);
  if (x1 > x2)
    {
      bx = x1;
      x1 = x2;
      x2 = bx;
    }
  if (y1 > y2)
    {
      by = y1;
      y1 = y2;
      y2 = by;
    }
  if (x1 == x2 || y1 == y2)
    return;
  /*
     printf("%f %f %f %f \n ",x1,y1,x2,y2);
     printf("%f %f %f %f \n",MyGraph->xlo,MyGraph->ylo,MyGraph->xhi,MyGraph->yhi);

   */
  bx = dx * dx / (x2 - x1);
  mux = (x1 - MyGraph->xlo) / dx;
  MyGraph->xlo = MyGraph->xlo - bx * mux;
  MyGraph->xhi = MyGraph->xlo + bx;

  by = dy * dy / (y2 - y1);
  muy = (y1 - MyGraph->ylo) / dy;
  MyGraph->ylo = MyGraph->ylo - by * muy;
  MyGraph->yhi = MyGraph->ylo + by;

  if (MyGraph->grtype < 5)
    {
      MyGraph->xmin = MyGraph->xlo;
      MyGraph->xmax = MyGraph->xhi;
      MyGraph->ymin = MyGraph->ylo;
      MyGraph->ymax = MyGraph->yhi;
    }
  check_windows ();
  redraw_the_graph ();
//  draw_help ();
}




graph_all (list, n, type)
     int *list, n, type;
{

}


find_color (in)
{
}

alter_curve (title, in_it, n)
     char *title;
     int in_it, n;
{
 static char *nn[]={"*0X-axis","*0Y-axis","*0Z-axis","*4Color","Line type"};
 char values[5][MAX_LEN_SBOX];
 int status,i;
 int i1=MyGraph->xv[in_it],i2=MyGraph->yv[in_it],i3=MyGraph->zv[in_it];
 char n1[15],n2[15],n3[15];


 ind_to_sym(i1,n1);
 ind_to_sym(i2,n2);
 ind_to_sym(i3,n3);
 sprintf(values[0],"%s",n1);
 sprintf(values[1],"%s",n2);
 sprintf(values[2],"%s",n3);
 sprintf(values[3],"%d",MyGraph->color[in_it]);
 sprintf(values[4],"%d",MyGraph->line[in_it]);
 status=do_string_box(5,5,1,title,nn,values,25);
 if(status!=0){
                    find_variable(values[0],&i);
              if(i>-1)
                MyGraph->xv[n]=i;
              find_variable(values[1],&i);
              if(i>-1)
                MyGraph->yv[n]=i;
              find_variable(values[2],&i);
                if(i>-1)
                  MyGraph->zv[n]=i;

               MyGraph->line[n]=atoi(values[4]);
               i=atoi(values[3]);
                    if(i<0||i>10)i=0;
                    MyGraph->color[n]=i;

                  return(1);

              }
 return(0);

}


edit_curve ()
{
}

new_curve ()
{
}

create_ps ()
{
}

/* 
ps_test()
{
 double xlo=MyGraph->xlo,xhi=MyGraph->xhi,ylo=MyGraph->ylo,yhi=MyGraph->yhi;
 text_abs((float)xlo,(float)ylo,"lolo");
 text_abs((float)xlo,(float)yhi,"lohi");
 text_abs((float)xhi,(float)ylo,"hilo");
 text_abs((float)xhi,(float)yhi,"hihi");
 ps_end();
}
 
*/


change_cmap_com (int i)
{
}

freeze_com (int c)
{

}

set_key (x, y)
     int x, y;
{
}

draw_freeze_key ()
{
}

key_frz_com (int c)
{
}

edit_frz ()
{
}


delete_frz_crv (i)
     int i;
{
}

delete_frz ()
{
}


kill_frz ()
{
}

freeze_crv (ind)
     int ind;
{
}

auto_freeze_it ()
{
}

create_crv (ind)
     int ind;
{
}


edit_frz_crv (i)
     int i;
{
}

/*
draw_frozen_cline (index, w)
     int index;
     Window w;
{
}
*/

/*
draw_freeze (w)
     Window w;
{
}
*/

/*  Bifurcation curve importing */

init_bd ()
{
}

/*
draw_bd (w)
     Window w;
{
}
*/

free_bd ()
{
}


add_bd_crv (x, y, len, type, ncrv)
     float *x, *y;
     int len, ncrv, type;
{
}

frz_bd ()
{
}

read_bd (fp)
     FILE *fp;
{
}

/*
get_frz_index (w)
     Window w;
{

}
*/






export_graf_data ()
{
}

add_a_curve_com (int c)
{

}
