#include <stdio.h>
#include <math.h>
#include <time.h>
#include <ctype.h>
#include "xpplim.h"
#include "shoot.h"

#define MAX_LEN_SBOX 25
#define MAXLINES 5000
#define PARAMBOX 1
#define ICBOX 2
#define DELAYBOX 3
#define BCBOX 4

extern int NUPAR, NODE, NEQ, NMarkov, NLINES;
extern char *save_eqn[MAXLINES];
extern char upar_names[MAXPAR][11], uvar_names[MAXODE][12];
extern char this_file[100];
extern double last_ic[MAXODE];
extern BC_STRUCT my_bc[MAXODE];

find_user_name (type, oname)
     int type;
     char *oname;
{
  char name[25];
  int j = 0, k = 0, i = -1;
  for (j = 0; j < strlen (oname); j++)
    {
      if (!isspace (oname[j]))
	{
	  name[k] = oname[j];
	  k++;
	}
    }
  name[k] = 0;


  for (i = 0; i < NUPAR; i++)
    if ((type == PARAMBOX) && (strcasecmp (upar_names[i], name) == 0))
      break;
  if (i < NUPAR)
    return (i);
  for (i = 0; i < NEQ; i++)
    if ((type == ICBOX) && (strcasecmp (uvar_names[i], name) == 0))
      break;
  if (i < NEQ)
    return (i);
  return (-1);
}

file_selector (title, file, wild)
     char *title;
     char *wild, *file;
{
  return 0;
}

man_ic ()
{
  int done, index = 0;
  double z;
  char name[256], value[256], junk[256];
  while (1)
    {
      sprintf (name, "%s :", uvar_names[index]);
      z = last_ic[index];
      done = new_float (name, &z);
      if (done == 0)
	{
	  last_ic[index] = z;
	  sprintf (junk, "%.16g", z);
//          set_edit_params (&ICBox, index, junk);
//          draw_one_box (ICBox, index);
	  index++;
	  if (index >= NODE + NMarkov)
	    return;
	}
      if (done == -1)
	return;
    }
}

/* CLONE */
clone_ode (clone)
  char *clone;
{
  int i, j, x, y;
  FILE *fp;
//  char clone[256];
  char bob[1024];
  char *s;
  time_t ttt;
  double z;
//  clone[0] = 0;
//  if (!file_selector ("Clone ODE file", clone, "*.ode"))
//    return;
  if ((fp = fopen (clone, "w")) == NULL)
    {
      err_msg (" Cant open clone file");
      return;
    }
  ttt = time (0);
  fprintf (fp, "# clone of %s on %s", this_file, ctime (&ttt));
  for (i = 0; i < NLINES; i++)
    {
      s = save_eqn[i];

      if (s[0] == 'p' || s[0] == 'P' || s[0] == 'b' || s[0] == 'B')
	{
	  x = find_char (s, "'", 0, &j);
	  y = find_char (s, "=", 0, &j);

	  if (x != 0 || y != 0)
	    {
	      fprintf (fp, "\n# original\n# %s\n", s);
	      continue;
	    }
	}
      if (strncasecmp ("done", s, 4) == 0)
	continue;
      fprintf (fp, "%s\n", s);
    }
  fprintf (fp, "# Cloned parameters etc here\n");
  /* now we do parameters boundary conds and ICs */
  j = 0;
  fprintf (fp, "init ");
  for (i = 0; i < (NODE + NMarkov); i++)
    {
      if (j == 8)
	{
	  fprintf (fp, "\ninit ");
	  j = 0;
	}

      fprintf (fp, "%s=%g ", uvar_names[i], last_ic[i]);
      j++;
    }
  fprintf (fp, "\n");

  /* BDRY conds */
  if (my_bc[0].string[0] != '0')
    {
      for (i = 0; i < NODE; i++)
	fprintf (fp, "bdry %s\n", my_bc[i].string);
    }
  j = 0;
  if (NUPAR > 0)
    {

      fprintf (fp, "par ");
      for (i = 0; i < NUPAR; i++)
	{
	  if (j == 8)
	    {
	      fprintf (fp, "\npar ");
	      j = 0;
	    }
	  get_val (upar_names[i], &z);
	  fprintf (fp, "%s=%g ", upar_names[i], z);
	  j++;
	}
    }
  fprintf (fp, "\n");
  fprintf (fp, "done \n");
  fclose (fp);
}
