#include <math.h>
#include <stdio.h>
#include <stdarg.h>
#include "browse.h"
#include "struct.h"
#include "defines.h"
#include "interface.h"

#define cstring 0.01

int
onGo (char *inputFile, char *outputFile, int outputFlag)
{
  int flag;
  char pptitle[80];
  sprintf (this_file, inputFile);
  got_file = 1;

  Xup = 1;

  flag = load_eqn ();
  if (flag == ODE_ERROR)
    return ODE_ERROR;
  init_alloc_info ();
  set_all_vals ();
  set_init_guess ();
  update_all_ffts ();
#ifdef AUTO
  init_auto_win ();
#endif

  if (disc (this_file))
    METHOD = 0;
  xppver = (float) cstring;
  if (strlen (this_file) < 60)
    sprintf (pptitle, "XPP Ver %g >> %s", xppver, this_file);
  else
    sprintf (pptitle, "XPP Version %g", xppver);

  do_meth ();
  set_delay ();
  rhs = my_rhs;
  init_fit_info ();
  strip_saveqn ();
  create_plot_list ();

  if (outputFlag == RUNBATCH)
    {
      XPPBatch = 1;
      Xup = 0;
      //sprintf (batchout, outputFile);
      sprintf (batchout, "output.dat");
      init_browser ();
      init_all_graph ();
      // if_needed_load_set ();
      batch_integrate ();
      return 0;
    }
  init_grafs ();
  init_browser ();
  if (outputFlag == RUNPS)
    {
      //sprintf (batchout, outputFile);
      sprintf (batchout, "output.ps");
      ps_init ("output.ps", 0);
      return 0;
    }
  do_axes ();
  if (outputFlag == RUNLOAD)
    return 0;
  run_now ();

  return 0;
}

void
GetWidthHeight (int *w, int *h)
{
  // Set by setCurrentGraph
//  printLog("%i, %i\n", XDMax, YDMax);
  *w = XDMax;
  *h = YDMax;
}

void
printLog (const char *fmt, ...)
{
  va_list ap;
  va_start (ap, fmt);
  wxPrintLog (fmt, ap);
}
