/*
This is part of the C++ side of the numerical/GUI interface for XPPAUT

#include interface_wx.h in any GUI file that needs to talk to
the C functions.

These functions are NOT available to C files as they do not understand
wxWidgets types such as wxString.  Use /src/interface.cpp instead.
*/
#include <stdio.h>
#include <stdarg.h>
#include <wx/wxprec.h>

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#endif

#include <wx/grid.h>
#include <wx/combobox.h>

#include "xppLogWindow_wx.h"
#include "xppPlotCanvas_wx.h"
#include "Ccode/interface.h"

#include "interfaceCPP_wx.h"

extern xppLogWindow *appLog;

void redrawCurrentGraph(xppPlotCanvas *theGraph)
{
  setCurrentGraph(theGraph);
  get_draw_area();
  redraw_the_graph();
}

void setCurrentGraph (xppPlotCanvas *theGraph)
{
  theGraph->GetClientSize(&XDMax, &YDMax);
  select_window(theGraph->GetIndex());
}

void setBigFontParams (wxDC *dc)
{
  int w, h, descent, externalLeading;
  dc->GetTextExtent(wxString(_T("W")), &w, &h, &descent, &externalLeading);

  DCURXb = w;
  DCURYb = h; // + externalLeading;
  CURY_OFFb = externalLeading + 1;
}

void setSmallFontParams (wxDC *dc)
{
  int w, h, descent, externalLeading;
  dc->GetTextExtent(wxString(_T("W")), &w, &h, &descent, &externalLeading);

  DCURXs = w;
  DCURYs = h + externalLeading;
  CURY_OFFs = externalLeading + 1;
}

void resizedGraph (xppPlotCanvas *theGraph)
{
  MyGraph = &graph[theGraph->GetIndex()];

  theGraph->GetClientSize(&XDMax, &YDMax);
  get_draw_area();
  redraw_the_graph();
}

void getGraphMaxMin(double *Xmin, double *Xmax, double *Ymin, double *Ymax)
{
  *Xmin = MyGraph->xmin;
  *Xmax = MyGraph->xmax;
  *Ymin = MyGraph->ymin;
  *Ymax = MyGraph->ymax;
}

