/*
xppAutoCanvas_wx.h

*/

#ifndef __XPPAUTOCANH__
#define __XPPAUTOCANH__

class xppAutoWindow;

class xppAutoCanvas : public wxPanel
{
  public:
    xppAutoCanvas() {};
    xppAutoCanvas(wxWindow *parent, xppAutoWindow *w);
    wxFont* GetBigFont();
    wxFont* GetSmallFont();
    void SetBigFont(wxFont font);
    void SetSmallFont(wxFont font);
    void OnPaint(wxPaintEvent &event);
    void DrawPlot(wxDC &dc);
    void DrawBitmap(wxBitmap *bitmap);
    void OnSize(wxSizeEvent &event);
    void OnMouse(wxMouseEvent &event);
  private:
    xppAutoWindow *autoWindow;
    wxClientDC *autoCanvasDC;
    wxFont *bigFont;
    wxFont *smallFont;

  DECLARE_DYNAMIC_CLASS(xppAutoCanvas)
  DECLARE_EVENT_TABLE()
};

extern "C" {
  void redraw_diagram();
  void draw_bif_axes();
  void do_auto(int iold, int isave, int itp);
}

#endif

