/*
xppAutoDialogs_wx.h

Defines all dialogs the xppAutoWindow uses
*/

#ifndef __XPPADIALOGSH__
#define __XPPADIALOGSH__

class xppAutoWindow;

extern "C" int AutoPar[5];

class AutoAxesDlg : public wxDialog
{
  public:
    AutoAxesDlg(xppAutoWindow *p);
    void OnAxesChoice(wxCommandEvent &WXUNUSED(event));
//    void Disable3D();
//    void Enable3D();
    void UpdateValues();
    void UpdateDisplay();

  private:
    xppAutoWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxTextCtrl **inputs;
    wxChoice **choices;
    wxRadioBox *radioBox;
    wxCheckBox *fitCheck;

    wxButton *okButton;
    wxButton *applyButton;
    wxButton *applyGoButton;
    wxButton *defaultButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;

  DECLARE_EVENT_TABLE()
};

enum
{
  AAXES_CHOICE = 200,
};

class AutoNumericsDlg : public wxDialog
{
  public:
    AutoNumericsDlg(xppAutoWindow *p);
    void UpdateValues();
    void UpdateDisplay();

  private:
    xppAutoWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxTextCtrl **inputs;

    wxButton *okButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;
};

class AutoParamDlg : public wxDialog
{
  public:
    AutoParamDlg(xppAutoWindow *p);
    void UpdateValues();
    void UpdateDisplay();

  private:
    xppAutoWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxChoice **choices;

    wxButton *okButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;
};

#endif

