/*
xppAutoWindow_wx.cpp

AUTO... whew.
*/

#include <wx/wxprec.h>

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#endif

#include "Ccode/autow.h"

#include <wx/image.h>

#include "xppRunWindow_wx.h"
#include "xppAutoCanvas_wx.h"
#include "xppAutoDialogs_wx.h"
#include "xppAutoWindow_wx.h"

extern AUTOWIN *AutoW;

#define MAX_AUT_PER 10                              
typedef struct
{   
  int exist; 
  int ntst, nmx, npr;
  double ds, dsmax, dsmin, rl0, rl1, a0, a1;        
  double xmin, xmax, ymin, ymax;                    
  double lastx, lasty;
  int wid, hgt, x0, y0, st_wid;                     
  int nfpar, nbc;
  int ips, irs, ilp, isp, isw, itp;                 
  int plot, var;                                    
  int icp1, icp2, icp3, icp4, icp5;                 
  int nper;                                         
  char hinttxt[256];                                
  double period[MAX_AUT_PER];                       
  int uzrpar[MAX_AUT_PER];                          
  double epsl, epsu, epss;                          
  int ncol;                                         
} BIFUR;                                            

extern BIFUR Auto;

typedef struct
{
  int package;
  int ibr, ntot, itp, lab;
  double norm, uhi[MAXODE], ulo[MAXODE], u0[MAXODE], ubar[MAXODE];
  double par[20], per, torper;
  int index, nfpar, icp1, icp2, icp3, icp4, icp5;
  int flag;
} GRABPT;

extern GRABPT grabpt;
extern "C" int NODE;
extern "C" int HOMOCLINIC_FLAG;
extern "C" int METHOD;


BEGIN_EVENT_TABLE(xppAutoWindow, wxFrame)
  /* File menu */
  EVT_MENU (A_IMPORT_ORBIT,  xppAutoWindow::OnImportOrbit  )
  EVT_MENU (A_SAVE_DIAGRAM,  xppAutoWindow::OnSaveDiagram  )
  EVT_MENU (A_LOAD_DIAGRAM,  xppAutoWindow::OnLoadDiagram  )
  EVT_MENU (A_PS,            xppAutoWindow::OnPostscript   )
  EVT_MENU (A_WRITE_PTS,     xppAutoWindow::OnWritePoints  )
  EVT_MENU (A_ALL_INFO,      xppAutoWindow::OnAllInfo      )
  EVT_MENU (A_INIT_DATA,     xppAutoWindow::OnInitData     )
  EVT_MENU (A_CLOSE,         xppAutoWindow::OnClose        )
  EVT_MENU (A_EXPORT_IMG,    xppAutoWindow::OnExportImg    )

  /* Edit menu */
  EVT_MENU (A_PARAM,         xppAutoWindow::OnParam        )
  EVT_MENU (A_NUMERICS,      xppAutoWindow::OnNumerics     )
  EVT_MENU (A_GRAB,          xppAutoWindow::OnGrab         )
  EVT_MENU (A_CLEAR_GRAB,    xppAutoWindow::OnClearGrab    )
  EVT_MENU (A_RESET_DIAGRAM, xppAutoWindow::OnResetDiagram )

  /* Grabbing keys and escape */
  EVT_MENU (A_GRAB_PREV, xppAutoWindow::OnGrabPrev  )
  EVT_MENU (A_GRAB_NEXT, xppAutoWindow::OnGrabNext  )
  EVT_MENU (A_GRAB_TAB,  xppAutoWindow::OnGrabTab   )
  EVT_MENU (A_GRAB_END,  xppAutoWindow::OnGrabEnd   )
  EVT_MENU (A_ESC,       xppAutoWindow::OnEscapeKey )

  /* View menu */
  EVT_MENU (A_AXES,       xppAutoWindow::OnAxes     )
  EVT_MENU (A_LAST_1_PAR, xppAutoWindow::OnLast1Par )
  EVT_MENU (A_LAST_2_PAR, xppAutoWindow::OnLast2Par )
  EVT_MENU (A_ZOOM,       xppAutoWindow::OnZoom     )
  EVT_MENU (A_FIT,        xppAutoWindow::OnFit      )
  EVT_MENU (A_CLEAR,      xppAutoWindow::OnClear    )
  EVT_MENU (A_REDRAW,     xppAutoWindow::OnRedraw   )

  /* Run menu */
  EVT_MENU (A_START_STEADY_STATE,  xppAutoWindow::OnStartSteadyState  )
  EVT_MENU (A_START_PERIODIC,      xppAutoWindow::OnStartPeriodic     )
  EVT_MENU (A_START_BDRY_VALUE,    xppAutoWindow::OnStartBdryValue    )
  EVT_MENU (A_START_HOMOCLINIC,    xppAutoWindow::OnStartHomoclinic   )
  EVT_MENU (A_START_DISCRETE,    xppAutoWindow::OnStartDiscrete   )

  EVT_MENU (A_HOPF_PERIODIC,    xppAutoWindow::OnHopfPeriodic   )
  EVT_MENU (A_HOPF_EXTEND,    xppAutoWindow::OnHopfExtend   )
  EVT_MENU (A_HOPF_NEW_PT,    xppAutoWindow::OnHopfNewPt   )
  EVT_MENU (A_HOPF_TWO_PAR,    xppAutoWindow::OnHopfTwoPar   )

  EVT_MENU (A_PERDOUB_DOUB,    xppAutoWindow::OnPeriodDoubDoubling   )
  EVT_MENU (A_PERDOUB_TWO_PAR,    xppAutoWindow::OnPeriodDoubTwoParam   )
  EVT_MENU (A_PERDOUB_FIX_PER,    xppAutoWindow::OnPeriodDoubFixedPeriod   )
  EVT_MENU (A_PERDOUB_EXTEND,    xppAutoWindow::OnPeriodDoubExtend   )

  EVT_MENU (A_TORUS_TWO_PAR,    xppAutoWindow::OnTorusTwoParam   )
  EVT_MENU (A_TORUS_FIX_PER,    xppAutoWindow::OnTorusFixedPeriod   )
  EVT_MENU (A_TORUS_EXTEND,    xppAutoWindow::OnTorusExtend   )

  EVT_MENU (A_PERIODIC_EXTEND,    xppAutoWindow::OnPeriodicExtend   )
  EVT_MENU (A_PERIODIC_FIX_PER,    xppAutoWindow::OnPeriodicFixedPeriod   )

  EVT_MENU (A_CONT_LIMIT_PT,    xppAutoWindow::OnContLimitPt   )
  EVT_MENU (A_CONT_BRANCH_PT,    xppAutoWindow::OnContBranchPt   )
  EVT_MENU (A_CONT_STEAD_STATE,    xppAutoWindow::OnContSteadState   )
  EVT_MENU (A_UNLABELED_PT,    xppAutoWindow::OnUnlabeledPt   )

  EVT_CLOSE ( xppAutoWindow::OnCloseWindow)
END_EVENT_TABLE()

xppAutoWindow::xppAutoWindow(xppRunWindow *w, wxPoint pos)
  : wxFrame(w, -1, _T("AUTO"), pos)
{
  runWindow = w;
  autoPanel = (wxPanel*) NULL;
  runIsSet = false;

  int width, height;
  grabbing = false;

  autoFrameSizer = new wxBoxSizer(wxVERTICAL);
  autoPanelSizer = new wxBoxSizer(wxVERTICAL);
  autoCanvasSizer = new wxBoxSizer(wxVERTICAL);

  wxAcceleratorEntry entries[5];
  entries[0].Set(wxACCEL_NORMAL, WXK_ESCAPE, A_ESC);
  entries[1].Set(wxACCEL_NORMAL, WXK_RETURN, A_GRAB_END);
  entries[2].Set(wxACCEL_NORMAL, WXK_LEFT, A_GRAB_PREV);
  entries[3].Set(wxACCEL_NORMAL, WXK_RIGHT, A_GRAB_NEXT);
  entries[4].Set(wxACCEL_NORMAL, WXK_TAB, A_GRAB_TAB);

  wxAcceleratorTable accelTable(5, entries);
  SetAcceleratorTable(accelTable);

#if wxUSE_MENUS
  // Export submenu
  wxMenu *exportMenu = new wxMenu();
  exportMenu->Append(A_EXPORT_IMG, _T("Image"), _T("Save graph to an image file"));
  exportMenu->Append(A_PS,_T("Postscript..."),
    _T("Create postscript file of picture"));
  exportMenu->AppendSeparator();
  exportMenu->Append(A_WRITE_PTS,_T("Write Pts..."),
    _T("Write the x-y values of the current diagram to file"));
  exportMenu->Append(A_INIT_DATA,_T("Init Data..."),
    _T("Save initial data for whole diagram"));
  exportMenu->Append(A_ALL_INFO,_T("All Info..."),
    _T("Write all the info for the whole diagram!"));

  //File menu
  wxMenu *fileMenu = new wxMenu();
  fileMenu->Append(A_SAVE_DIAGRAM,_T("Save Diagram..."),
    _T("Write diagram info to file for reuse"));
  fileMenu->Append(A_LOAD_DIAGRAM,_T("Load Diagram..."),
    _T("Load previously saved file for restart"));
  fileMenu->AppendSeparator();
  fileMenu->Append(A_IMPORT_ORBIT,_T("Import Orbit..."),
    _T("Load a computed orbit into XPP"));
  fileMenu->AppendSeparator();
  fileMenu->Append(A_EXPORT, _T("Export"), exportMenu, _T(""));
  fileMenu->AppendSeparator();
  fileMenu->Append(A_CLOSE, _T("Close"),
    _T("Close and reset AUTO"));

  wxMenu *editMenu = new wxMenu();
  editMenu->Append(A_PARAM,_T("Parameters"),
    _T("Tell AUTO the parameters you may vary"));
  editMenu->Append(A_NUMERICS,_T("Numerics"),
    _T("Tell AUTO range, direction, and tolerance"));
  editMenu->AppendSeparator();
  editMenu->Append(A_GRAB,_T("Grab"),
    _T("Grab a point to continue from"));
  editMenu->Append(A_CLEAR_GRAB,_T("Clear Grab"),
    _T("Clear grab point to allow start from a new point"));
  editMenu->AppendSeparator();
  editMenu->Append(A_RESET_DIAGRAM,_T("Reset Diagram"),
    _T("Delete all points of diagram and all associated files"));

  wxMenu *viewMenu = new wxMenu();
  viewMenu->Append(A_AXES,_T("Axes"),
    _T("What will be plotted on the axes and what parameters"));
  viewMenu->AppendSeparator();
  viewMenu->Append(A_LAST_1_PAR,_T("Last 1 Par"),
    _T("Recall last 1 parameter plot"));
  viewMenu->Append(A_LAST_2_PAR,_T("Last 2 Par"),
    _T("Recall last 2 parameter plot"));
  viewMenu->AppendSeparator();
  viewMenu->Append(A_ZOOM,_T("Zoom (NW)"),
    _T("Zoom in with the mouse"));
  viewMenu->Append(A_FIT,_T("Fit"),
    _T("Let XPP determine the bounds of the plot"));
  viewMenu->AppendSeparator();
  viewMenu->Append(A_CLEAR,_T("Clear Screen"),
    _T("Erase the screen"));
  viewMenu->Append(A_REDRAW,_T("Redraw Screen"),
    _T("Redraw the screen"));
/*
  axesMenu->Append(A_HI,_T("Hi..."),
    _T("Plot maximum of variable vs parameter"));
  axesMenu->Append(A_NORM,_T("Norm..."),
    _T("Plot norm of solution vs parameter"));
  axesMenu->Append(A_HI_LO,_T("Hi-Lo..."),
    _T("Plot max/min of variable vs parameter"));
  axesMenu->Append(A_PERIOD,_T("Period..."),
    _T("Plot period of orbit vs parameter"));
  axesMenu->Append(A_TWO_PAR,_T("Two Par..."),
    _T("Set up two-parameter bifurcation"));
  axesMenu->Append(A_LAST_1_PAR,_T("Last 1 Par"),
    _T("Recall last 1 parameter plot"));
  axesMenu->Append(A_LAST_2_PAR,_T("Last 2 Par"),
    _T("Recall last 2 parameter plot"));
  axesMenu->Append(A_FREQ,_T("Frequency..."),
    _T("Plot frequency vs parameter"));
  axesMenu->Append(A_AVERAGE,_T("Average..."),
    _T("Plot average of orbit vs parameter"));
*/

  wxMenu *startMenu = new wxMenu();
  startMenu->Append(A_START_STEADY_STATE,_T("Steady State"),
    _T("Start at fixed point"));
  startMenu->Append(A_START_PERIODIC,_T("Periodic"),
    _T("Start at periodic orbit"));
  startMenu->Append(A_START_BDRY_VALUE,_T("Boundry Value"),
    _T("Start at solution to boundary value problem"));
  startMenu->Append(A_START_HOMOCLINIC,_T("Homoclinic..."),
    _T("Use integral phase condn for homoclinics"));
  startMenu->Append(A_START_DISCRETE,_T("Discrete"),
    _T(""));

  wxMenu *hopfMenu = new wxMenu();
  hopfMenu->Append(A_HOPF_PERIODIC,_T("Periodic"),
    _T(""));
  hopfMenu->Append(A_HOPF_EXTEND,_T("Extend"),
    _T(""));
  hopfMenu->Append(A_HOPF_NEW_PT,_T("New Point"),
    _T(""));
  hopfMenu->Append(A_HOPF_TWO_PAR,_T("Two Parameter"),
    _T(""));

  wxMenu *perdoubMenu = new wxMenu();
  perdoubMenu->Append(A_PERDOUB_DOUB,_T("Doubling"),
    _T(""));
  perdoubMenu->Append(A_PERDOUB_EXTEND,_T("Extend"),
    _T(""));
  perdoubMenu->Append(A_PERDOUB_TWO_PAR,_T("Two Parameter"),
    _T(""));
  perdoubMenu->Append(A_PERDOUB_FIX_PER,_T("Fixed Period"),
    _T(""));

  wxMenu *torusMenu = new wxMenu();
  torusMenu->Append(A_TORUS_EXTEND,_T("Extend"),
    _T(""));
  torusMenu->Append(A_TORUS_TWO_PAR,_T("Two Parameter"),
    _T(""));
  torusMenu->Append(A_TORUS_FIX_PER,_T("Fixed Period"),
    _T(""));

  wxMenu *periodicMenu = new wxMenu();
  torusMenu->Append(A_PERIODIC_EXTEND,_T("Extend"),
    _T(""));
  torusMenu->Append(A_PERIODIC_FIX_PER,_T("Fixed Period"),
    _T(""));

  wxMenu *runMenu = new wxMenu();
  runMenu->Append(A_START, _T("Start"), startMenu, _T("Start choices"));
  runMenu->Append(A_HOPF, _T("Hopf"), hopfMenu, _T("Hopf choices"));
  runMenu->Append(A_PERDOUB, _T("Period Doubling"), perdoubMenu, _T("Period Doubling choices"));
  runMenu->Append(A_TORUS, _T("Torus"), torusMenu, _T("Torus choices"));
  runMenu->Append(A_PERIODIC, _T("Periodic"), periodicMenu, _T("Periodic choices"));
  runMenu->AppendSeparator();
  runMenu->Append(A_CONT_LIMIT_PT,_T("Continue Limit Pt"), _T(""));
  runMenu->Append(A_CONT_BRANCH_PT,_T("Continue Branch Pt"), _T(""));
  runMenu->Append(A_CONT_STEAD_STATE,_T("Continue Steady State"), _T(""));
  runMenu->Append(A_UNLABELED_PT,_T("Unlabeled Point"), _T(""));

/*
  0 through 9
*/

//  wxMenu *periodMenu = new wxMenu();

  wxMenuBar *autoMenuBar = new wxMenuBar();
  autoMenuBar->Append(fileMenu, _T("&File"));
  autoMenuBar->Append(editMenu, _T("&Edit"));
  autoMenuBar->Append(viewMenu, _T("&View"));
  autoMenuBar->Append(runMenu, _T("&Run"));

  SetMenuBar(autoMenuBar);
#endif // wxUSE_MENUS

#if wxUSE_STATUSBAR
  CreateStatusBar();
  SetStatusText(_T("AUTO"));
#endif // wxUSE_STATUSBAR

  autoPanel = new wxPanel(this, -1);
  autoCanvas = new xppAutoCanvas(autoPanel, this);
  autoInfo = new wxTextCtrl(autoPanel, -1, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE | wxTE_READONLY);

  wxFont infoFont(10, wxMODERN, wxNORMAL, wxNORMAL);
  wxTextAttr infoAttr(*wxBLACK, *wxWHITE, infoFont);
  autoInfo->SetDefaultStyle(infoAttr);

  make_auto(&width, &height);

  autoFrameSizer->Add(autoPanelSizer,1,wxEXPAND);
  autoPanelSizer->Add(autoCanvasSizer,6,wxEXPAND);
  autoPanelSizer->Add(autoInfo,1,wxEXPAND|wxALL, 3);
  autoCanvasSizer->Add(autoCanvas,1,wxEXPAND);

  autoPanel->SetSizer(autoPanelSizer);

  autoCanvasSizer->SetDimension(0, 0, width, height);
  autoFrameSizer->SetMinSize(wxSize(640,480));
  autoFrameSizer->Fit(this);

  SetRunMenu();
}

// File menu

void xppAutoWindow::OnImportOrbit(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Open AUTO Orbit..."),_T(""),_T(""),_T("AUTO Orbit (*.q)|*.q|All files (*.*)|*.*"), wxOPEN|wxFILE_MUST_EXIST);
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    load_auto_orbit(filename);
  }
}

void xppAutoWindow::OnSaveDiagram(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Save AUTO Diagram..."),_T(""),_T(""),_T("AUTO diagram (*.auto)|*.auto|All files(*.*)|*.*"), wxSAVE | wxOVERWRITE_PROMPT); 
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    save_auto(filename);
  }
}

void xppAutoWindow::OnLoadDiagram(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Open AUTO Diagram..."),_T(""),_T(""),_T("AUTO Diagram (*.auto)|*.auto|All files (*.*)|*.*"), wxOPEN|wxFILE_MUST_EXIST);
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    load_auto(filename);

    /* Redraw everything */
    clear_auto_plot();
    draw_bif_axes();
    redraw_diagram();
    autoCanvas->Refresh();
  }
}

void xppAutoWindow::OnExportImg(wxCommandEvent &event)
{
/*
File types supported:
Dialog filter index
-------------------
        0            wxBITMAP_TYPE_BMP
        1            wxBITMAP_TYPE_JPEG
        2            wxBITMAP_TYPE_PNG
        3            wxBITMAP_TYPE_PCX (tries 8-bit, 24-bit otherwise).
        4            wxBITMAP_TYPE_PNM (as raw RGB always).
        5            wxBITMAP_TYPE_XPM

In wxImage but not supported:
wxBITMAP_TYPE_ICO 	Windows Icon File - graphs are too big
wxBITMAP_TYPE_CUR 	Windows cursor file - graphs are too big
wxBITMAP_TYPE_TIFF 	UNISYS legal issues
*/

  wxFileDialog dialog(this,_T("Export Graph As..."),_T(""),_T(""),_T("Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|Portable Network Graphic (*.png)|*.png|PCX (*.pcx)|*.pcx|PNM (raw RGB *.pnm)|*.pnm)|XPM Bitmap (*.xpm)|*.xpm"), wxSAVE | wxOVERWRITE_PROMPT); 

  if (dialog.ShowModal() == wxID_OK)
  {
    int type = wxBITMAP_TYPE_BMP;
    int width, height;
    wxString filename = dialog.GetFilename();
    wxString directory = dialog.GetDirectory();
    wxString fullFilename = dialog.GetPath();
    wxString extension;

    autoCanvas->GetClientSize(&width, &height);

/*
    wxString msg;
    msg.Printf("%i, %i", width, height);
    wxMessageBox(msg, _T("About XPPAUT"), wxOK, this);
*/

    wxBitmap exportBitmap(width, height);

    autoCanvas->DrawBitmap(&exportBitmap);

    wxImage exportImage;
    exportImage = exportBitmap.ConvertToImage();

    switch(dialog.GetFilterIndex())
    {
      case 0:
        extension = _T(".bmp");
        type = wxBITMAP_TYPE_BMP;
        break;
      case 1:
        extension = _T(".jpg");
        type = wxBITMAP_TYPE_JPEG;
        break;
      case 2:
        extension = _T(".png");
        type = wxBITMAP_TYPE_PNG;
        break;
      case 3:
        extension = _T(".pcx");
        type = wxBITMAP_TYPE_PCX;
        break;
      case 4:
        extension = _T(".pnm");
        type = wxBITMAP_TYPE_PNM;
        break;
      case 5:
        extension = _T(".xpm");
        type = wxBITMAP_TYPE_XPM;
        break;
    }

    /* did they give the right extension? */
    if(filename.Right(4).IsSameAs(extension, false))
    {
      /* if so, save with their filename */
      exportImage.SaveFile(fullFilename, type);
    }
    else
    {
      /* if not, append the extension */
      exportImage.SaveFile(directory + filename + extension, type);
    }
  }
}

void xppAutoWindow::OnPostscript(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Save Postscript As..."),_T(""),_T(""),_T("Postscript (*.ps)|*.ps|All files (*.*)|*.*"), wxSAVE | wxOVERWRITE_PROMPT); 
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    post_auto(filename);
  }
}

void xppAutoWindow::OnClearGrab(wxCommandEvent &event)
{
  grabpt.flag = 0;
  autoInfo->Clear();
  SetRunMenu();
}

void xppAutoWindow::OnWritePoints(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Save Points As..."),_T(""),_T(""),_T("Point Data (*.dat)|*.dat|All files (*.*)|*.*"), wxSAVE | wxOVERWRITE_PROMPT); 
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    write_pts(filename);
  }
}

void xppAutoWindow::OnAllInfo(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Save As..."),_T(""),_T(""),_T("All AUTO Data (*.dat)|*.dat|All files (*.*)|*.*"), wxSAVE | wxOVERWRITE_PROMPT); 
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    write_info_out(filename);
  }
}

void xppAutoWindow::OnInitData(wxCommandEvent &event)
{
  wxFileDialog dialog(this,_T("Save As..."),_T(""),_T(""),_T("AUTO Init Data  (*.dat)|*.dat|All files (*.*)|*.*"), wxSAVE | wxOVERWRITE_PROMPT); 
  if (dialog.ShowModal() == wxID_OK)
  {
    char *filename;
    filename = (char *) malloc (sizeof (char)*(dialog.GetPath().Length()));
#ifdef wxUSE_UNICODE
    strcpy(filename, dialog.GetPath().mb_str());
#else
    strcpy(filename, dialog.GetPath().c_str());
#endif

    write_init_data_file(filename);
  }
}

void xppAutoWindow::OnClose(wxCommandEvent &event)
{
  wxMessageDialog dialog(this, _T("Close AUTO? Diagrams will be lost."),_T("Whoa there"), wxYES_NO);

  if(dialog.ShowModal() == wxID_YES)
  {
    yes_reset_auto();
    runWindow->AutoShutDown();
    Destroy();
  }
}

void xppAutoWindow::OnCloseWindow(wxCloseEvent &event)
{
  wxMessageDialog dialog(this, _T("Close AUTO? Diagrams will be lost."),_T("Whoa there"), wxYES_NO);

  if(dialog.ShowModal() == wxID_YES)
  {
    yes_reset_auto();
    runWindow->AutoShutDown();
    Destroy();
  }
}

// Edit menu

void xppAutoWindow::OnParam(wxCommandEvent &event)
{
  AutoParamDlg dlg(this);

  if(dlg.ShowModal() == wxID_OK)
  {
    dlg.UpdateValues();
    autoCanvas->Refresh();
  }
}

void xppAutoWindow::OnNumerics(wxCommandEvent &event)
{
  AutoNumericsDlg dlg(this);

  if(dlg.ShowModal() == wxID_OK)
  {
    dlg.UpdateValues();
    autoCanvas->Refresh();
  }
}

void xppAutoWindow::OnGrab(wxCommandEvent &event)
{
  int i;
  wxString tmp;
  wxMenuBar *menubar = GetMenuBar();
  int numMenus = menubar->GetMenuCount();

  /* disable the menus */
  for(i=0; i<numMenus; i++)
  {
    menubar->EnableTop(i, false);
  }

  /* Give instructions in status bar */
  SetStatusText(_T("ESC to cancel. Left, Right, and Tab to move. Enter to select a point"));
  
  /* Grab the initial point */
  grabbing = true;
  auto_grab();
  autoCanvas->Refresh();
  autoCanvas->SetFocus();

  autoInfo->Clear();
  tmp.Printf(_T("%s"), AutoW->infoheader);
  autoInfo->AppendText(tmp);
  tmp.Printf(_T("%s"), AutoW->newinfo);
  autoInfo->AppendText(tmp);
}

void xppAutoWindow::OnGrabEnd(wxCommandEvent &event)
{
  if(grabbing)
  {
    int i;
    wxString tmp;
    wxMenuBar *menubar = GetMenuBar();
    int numMenus = menubar->GetMenuCount();
  
    /* Re-enable the menus */
    for(i=0; i<numMenus; i++)
    {
      menubar->EnableTop(i, true);
    }
  
    /* Clear the instructions */
    SetStatusText(_T(""));

    /* finished grabbing */
    auto_grab_done();
    grabbing = false;
    autoCanvas->Refresh();

    autoInfo->Clear();
    tmp.Printf(_T("%s"), AutoW->infoheader);
    autoInfo->AppendText(tmp);
    tmp.Printf(_T("%s"), AutoW->newinfo);
    autoInfo->AppendText(tmp);

    SetRunMenu();
  }
}

void xppAutoWindow::OnGrabPrev(wxCommandEvent &event)
{
  if(grabbing)
  {
    wxString tmp;
    auto_grab_prev();
    autoCanvas->Refresh();

    autoInfo->Clear();
    tmp.Printf(_T("%s"), AutoW->infoheader);
    autoInfo->AppendText(tmp);
    tmp.Printf(_T("%s"), AutoW->newinfo);
    autoInfo->AppendText(tmp);
  }
}

void xppAutoWindow::OnGrabNext(wxCommandEvent &event)
{
  if(grabbing)
  {
    wxString tmp;
    auto_grab_next();
    autoCanvas->Refresh();

    autoInfo->Clear();
    tmp.Printf(_T("%s"), AutoW->infoheader);
    autoInfo->AppendText(tmp);
    tmp.Printf(_T("%s"), AutoW->newinfo);
    autoInfo->AppendText(tmp);
  }
}

void xppAutoWindow::OnGrabTab(wxCommandEvent &event)
{
  if(grabbing)
  {
    wxString tmp;
    auto_grab_tab();
    autoCanvas->Refresh();

    autoInfo->Clear();
    tmp.Printf(_T("%s"), AutoW->infoheader);
    autoInfo->AppendText(tmp);
    tmp.Printf(_T("%s"), AutoW->newinfo);
    autoInfo->AppendText(tmp);
  }
}

void xppAutoWindow::OnEscapeKey(wxCommandEvent &event)
{
  if(grabbing)
  {
    int i;
    wxString tmp;
    wxMenuBar *menubar = GetMenuBar();
    int numMenus = menubar->GetMenuCount();
  
    /* Re-enable the menus */
    for(i=0; i<numMenus; i++)
    {
      menubar->EnableTop(i, true);
    }
  
    /* abort grabbing, clear grab */
    grabpt.flag = 0;
    redraw_diagram();
    //auto_grab_done();
    grabbing = false;
    autoCanvas->Refresh();

    autoInfo->Clear();
    tmp.Printf(_T("%s"), AutoW->infoheader);
    autoInfo->AppendText(tmp);
    tmp.Printf(_T("%s"), AutoW->newinfo);
    autoInfo->AppendText(tmp);

    SetRunMenu();
  }
}

void xppAutoWindow::OnResetDiagram(wxCommandEvent &event)
{
  reset_auto();
  autoCanvas->Refresh();
  SetRunMenu();
}

// View menu

void xppAutoWindow::OnAxes(wxCommandEvent &event)
{
  AutoAxesDlg dlg(this);

  if(dlg.ShowModal() == wxID_OK)
  {
    dlg.UpdateValues();

    if(Auto.plot < 4)
      keep_last_plot(1);
    else if(Auto.plot == 4)
      keep_last_plot(2);

    draw_bif_axes();
    redraw_diagram();
    autoCanvas->Refresh();
  }
}

void xppAutoWindow::OnLast1Par(wxCommandEvent &event)
{
  load_last_plot(1);
  draw_bif_axes();
  //auto_plot_par('1');
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnLast2Par(wxCommandEvent &event)
{
  load_last_plot(2);
  draw_bif_axes();
  //auto_plot_par('2');
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnZoom(wxCommandEvent &event)
{
  //auto_plot_par('z');
  // auto_rubber(...);
  // auto_zoom(...);
  // draw_bif_axes();
  autoCanvas->Refresh();
}

void xppAutoWindow::OnFit(wxCommandEvent &event)
{
  auto_fit();
  //auto_plot_par('f');
  clear_auto_plot();
  draw_bif_axes();
  redraw_diagram();
  autoCanvas->Refresh();
}

void xppAutoWindow::OnClear(wxCommandEvent &event)
{
  clear_auto_plot();
  draw_bif_axes();
  autoCanvas->Refresh();
}

void xppAutoWindow::OnRedraw(wxCommandEvent &event)
{
  clear_auto_plot();
  draw_bif_axes();
  redraw_diagram();
  autoCanvas->Refresh();
}

// Run menu

// Start choices
void xppAutoWindow::OnStartSteadyState(wxCommandEvent &event)
{
  auto_new_ss();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnStartPeriodic(wxCommandEvent &event)
{
  auto_new_per();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnStartBdryValue(wxCommandEvent &event)
{
  Auto.nbc = NODE;
  auto_start_at_bvp ();

  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnStartHomoclinic(wxCommandEvent &event)
{
  if (HOMOCLINIC_FLAG == 0)
    set_up_homoclinic ();
  if (HOMOCLINIC_FLAG == 0)
  {
    //err_msg ("Homoclinic stuff not set up right");
  }
  else
  {
    Auto.nbc = NODE - 1;
    auto_start_at_bvp ();
  }

  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnStartDiscrete(wxCommandEvent &event)
{
  auto_new_discrete ();
  autoCanvas->Refresh();
  SetRunMenu();
}

// Hopf choices
void xppAutoWindow::OnHopfPeriodic(wxCommandEvent &event)
{
  auto_new_per();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnHopfExtend(wxCommandEvent &event)
{
  auto_extend_ss();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnHopfNewPt(wxCommandEvent &event)
{
  auto_new_ss();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnHopfTwoPar(wxCommandEvent &event)
{
  auto_2p_hopf();
  autoCanvas->Refresh();
  SetRunMenu();
}

// Period Doubling choices
void xppAutoWindow::OnPeriodDoubDoubling(wxCommandEvent &event)
{
  auto_period_double();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnPeriodDoubTwoParam(wxCommandEvent &event)
{
  auto_twopar_double();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnPeriodDoubFixedPeriod(wxCommandEvent &event)
{
  auto_2p_fixper();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnPeriodDoubExtend(wxCommandEvent &event)
{
  auto_new_per();
  autoCanvas->Refresh();
  SetRunMenu();
}

// Torus choices
void xppAutoWindow::OnTorusTwoParam(wxCommandEvent &event)
{
  auto_torus();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnTorusFixedPeriod(wxCommandEvent &event)
{
  auto_2p_fixper();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnTorusExtend(wxCommandEvent &event)
{
  auto_new_per();
  autoCanvas->Refresh();
  SetRunMenu();
}

// Periodic choices
void xppAutoWindow::OnPeriodicExtend(wxCommandEvent &event)
{
  auto_new_per();
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnPeriodicFixedPeriod(wxCommandEvent &event)
{
  auto_2p_fixper();
  autoCanvas->Refresh();
  SetRunMenu();
}

// Various continuations
void xppAutoWindow::OnContLimitPt(wxCommandEvent &event)
{
  int itp, itp1, itp2;

  itp = grabpt.itp;
  itp1 = itp % 10;
  itp2 = itp / 10;

  /* limit point */
  if (itp1 == 2 || itp2 == 2)
  {
    Auto.ips = 1;
    auto_2p_limit (Auto.ips);
  }

  /* limit pt of periodic or BVP */
  if (itp1 == 5 || itp2 == 5)
  {
    auto_2p_limit (Auto.ips);
  }
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnContBranchPt(wxCommandEvent &event)
{
  if (grabpt.ibr < 0 && Auto.ips == 2)
    auto_switch_per ();
  else if (Auto.ips == 4)
    auto_switch_bvp ();
  else
    auto_switch_ss ();

  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnContSteadState(wxCommandEvent &event)
{
  /*  old steady state -- just extend it  */
  if (grabpt.ibr > 0 && Auto.ips != 4)
  {
    auto_extend_ss ();
  }

  if (grabpt.ibr > 0 && Auto.ips == 4)
  {
    auto_extend_bvp ();
  }
  autoCanvas->Refresh();
  SetRunMenu();
}

void xppAutoWindow::OnUnlabeledPt(wxCommandEvent &event)
{
  wxMessageDialog dialog(this, _T("Not a labeled point: New Start?"),_T("Unlabeled Point"), wxYES_NO);

  if(dialog.ShowModal() == wxID_YES)
  {
    auto_start_diff_ss();
    autoCanvas->Refresh();
    SetRunMenu();
  }
}

void xppAutoWindow::SetRunMenu()
{
  int itp1, itp2, itp, ips;

  wxString tmp;
  tmp.Printf(_T("Run"));
  wxMenu *runMenu;
  runMenu = GetMenuBar()->GetMenu(GetMenuBar()->FindMenu(tmp));

  /* disable everything */
  runMenu->Enable(A_START, false);
  runMenu->Enable(A_HOPF, false);
  runMenu->Enable(A_PERDOUB, false);
  runMenu->Enable(A_TORUS, false);
  runMenu->Enable(A_PERIODIC, false);
  runMenu->Enable(A_CONT_LIMIT_PT, false);
  runMenu->Enable(A_CONT_BRANCH_PT, false);
  runMenu->Enable(A_CONT_STEAD_STATE, false);
  runMenu->Enable(A_UNLABELED_PT, false);


  /* the first call to AUTO */
  /* or following resets and clear grabs */
  if (grabpt.flag == 0)
  {
    runMenu->Enable(A_START, true);

    /* Discrete */
    if(METHOD == 0)
    {
      runMenu->Enable(A_START_STEADY_STATE, false);
      runMenu->Enable(A_START_PERIODIC, false);
      runMenu->Enable(A_START_BDRY_VALUE, false);
      runMenu->Enable(A_START_HOMOCLINIC, false);
      runMenu->Enable(A_START_DISCRETE, true);
    }
    else
    {
      runMenu->Enable(A_START_STEADY_STATE, true);
      runMenu->Enable(A_START_PERIODIC, true);
      runMenu->Enable(A_START_BDRY_VALUE, true);
      runMenu->Enable(A_START_HOMOCLINIC, true);
      runMenu->Enable(A_START_DISCRETE, false);
    }

    return;
  }

  /* Grabbed an unlabeled point */
  if (grabpt.lab == 0)
  {
    runMenu->Enable(A_UNLABELED_PT, true);
    return;
  }

  itp = grabpt.itp;
  itp1 = itp % 10;
  itp2 = itp / 10;
  ips = Auto.ips;

  /* its a HOPF Point  */
  if (itp1 == 3 || itp2 == 3)
  {
    runMenu->Enable(A_HOPF, true);

    /* Discrete */
    if(METHOD == 0)
    {
      runMenu->Enable(A_HOPF_PERIODIC, false);
      runMenu->Enable(A_HOPF_EXTEND, false);
      runMenu->Enable(A_HOPF_NEW_PT, false);
      runMenu->Enable(A_HOPF_TWO_PAR, true);
    }
    else
    {
      runMenu->Enable(A_HOPF_PERIODIC, true);
      runMenu->Enable(A_HOPF_EXTEND, true);
      runMenu->Enable(A_HOPF_NEW_PT, true);
      runMenu->Enable(A_HOPF_TWO_PAR, true);
    }

    return;
  }

  /* period doubling */
  if (itp1 == 7 || itp2 == 7)
  {
    runMenu->Enable(A_PERDOUB, true);
    return;
  }

  /* limit point */
  if (itp1 == 2 || itp2 == 2)
  {
    runMenu->Enable(A_CONT_LIMIT_PT, true);
    return;
  }

  /* limit pt of periodic or BVP */
  if (itp1 == 5 || itp2 == 5)
  {
    runMenu->Enable(A_CONT_LIMIT_PT, true);
    return;
  }

  /* branch point  */
  if (itp1 == 6 || itp2 == 6 || itp1 == 1 || itp2 == 1)
  {
    runMenu->Enable(A_CONT_BRANCH_PT, true);
    return;
  }

  /* Torus 2 parameter */
  if (itp1 == 8 || itp2 == 8)
  {
    runMenu->Enable(A_TORUS, true);
    return;
  }

  /* its a periodic -- just extend it  */
  if (grabpt.ibr < 0)
  {
    runMenu->Enable(A_PERIODIC, true);
    return;
  }

  /*  old steady state -- just extend it  */
  if (grabpt.ibr > 0 && ips != 4)
  {
    runMenu->Enable(A_CONT_STEAD_STATE, true);
    return;
  }

  if (grabpt.ibr > 0 && ips == 4)
  {
    runMenu->Enable(A_CONT_STEAD_STATE, true);
    return;
  }
}

