/*
xppBndryWin_wx.cpp

Window that shows all initial data

*/
#include <wx/wxprec.h>

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#endif

#include <math.h>

#include "xppRunWindow_wx.h"

#include "xppBndryWin_wx.h"

BEGIN_EVENT_TABLE(xppBndryWin, wxDialog)
  EVT_BUTTON (BNDRY_CLOSE, xppBndryWin::OnCancel )
  EVT_CLOSE( xppBndryWin::OnCloseWindow )
END_EVENT_TABLE()

xppBndryWin::xppBndryWin(xppRunWindow *p)
  : wxDialog(p, -1, _T("Boundary Conditions"), wxDefaultPosition)
{
  int i;
  int n = NODE;
  wxString tmp;
  parent = p;

  panel = new wxPanel(this, -1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL | wxCLIP_CHILDREN | wxNO_BORDER);
  labels = new wxStaticText * [n];
  inputs = new wxTextCtrl * [n];

  closeButton = new wxButton(panel, BNDRY_CLOSE, _T("Close"));

  mainSizer = new wxBoxSizer(wxVERTICAL);
  panelSizer = new wxBoxSizer(wxVERTICAL);
  buttonSizer = new wxBoxSizer(wxHORIZONTAL);
  // make the grid approximately square
  gridSizer = new wxGridSizer(2 * (int)sqrt(n));

  for(i=0; i<n; i++)
  {
    labels[i] = new wxStaticText(panel, -1, _T("0="));

    tmp.Printf(_T("%s"), my_bc[i].string);
    inputs[i] = new wxTextCtrl(panel, -1, tmp, wxDefaultPosition,
      wxDefaultSize, wxTE_READONLY);

    gridSizer->Add(labels[i], 0, wxALIGN_RIGHT | wxALIGN_CENTER_VERTICAL);
    gridSizer->Add(inputs[i]);
  }

  buttonSizer->Add(closeButton, 0, wxALL, 3);

  mainSizer->Add(panelSizer, 1, wxEXPAND);

  panelSizer->Add(gridSizer, 1, wxEXPAND);
  panelSizer->Add(buttonSizer, 0, wxALL | wxALIGN_CENTER_VERTICAL | wxALIGN_CENTER_HORIZONTAL, 10);
  panelSizer->Layout();

  panel->SetSizer(mainSizer);
  panel->SetAutoLayout(true);

  mainSizer->Fit(this);
  CenterOnParent();
}

void xppBndryWin::OnCancel(wxCommandEvent &WXUNUSED(event))
{
  Hide();
}

void xppBndryWin::OnCloseWindow(wxCloseEvent &WXUNUSED(event))
{
  Hide();
}

