/*
xppCodePanel.h

Defines the text editor for the .ode file
*/

#ifndef __XPPCODEPANH__
#define __XPPCODEPANH__

class xppCodePanel : public wxPanel
{
  public:
    xppCodePanel(wxWindow* parent);
    bool LoadFile(const wxString &filename);
    bool SaveFile(const wxString &filename);
    bool IsModified();
    void SelectAll();
    wxTextCtrl* GetTextCtrl();
#if wxUSE_FINDREPLDLG
    void FindText();
    void FindReplaceText();
#endif
  private:
    wxTextCtrl *code;
    wxBoxSizer *codeSizer;
#if wxUSE_FINDREPLDLG
    wxFindReplaceData codeFindReplaceData;
    wxFindReplaceDialog *codeFindReplace;
    wxFindReplaceDialog *codeFind;
    void OnFind(wxFindDialogEvent &event);
    void OnFindNext(wxFindDialogEvent &event);
    void OnFindReplace(wxFindDialogEvent &event);
    void OnFindReplaceAll(wxFindDialogEvent &event);
    void OnFindClose(wxFindDialogEvent &event);
#endif

  DECLARE_EVENT_TABLE()
};

#endif
