/*
xppDataWindow_wx.h

Window that holds the numerical run data
*/

#ifndef __XPPDATAWINH__
#define __XPPDATAWINH__

#include "Ccode/xpplim.h"

class xppRunWindow;

class xppDataWindow : public wxFrame
{
  public:
    xppDataWindow(xppRunWindow *w);
    void OnRead    (wxCommandEvent &event);
    void OnWrite   (wxCommandEvent &event);
    void OnTable   (wxCommandEvent &event);
    void OnClose   (wxCommandEvent &event);
    void OnFind    (wxCommandEvent &event);
    void OnReplace (wxCommandEvent &event);
    void OnUndo    (wxCommandEvent &event);
    void OnAdd     (wxCommandEvent &event);
    void OnDel     (wxCommandEvent &event);
    void OnLoad    (wxCommandEvent &event);
    void OnRefresh (wxCommandEvent &event);
    void OnFirst   (wxCommandEvent &event);
    void OnLast    (wxCommandEvent &event);
    void OnCloseWindow   (wxCloseEvent &event);
  private:
    xppRunWindow *runWindow;
    wxBoxSizer *dataFrameSizer;
    wxBoxSizer *dataGridSizer;
    wxGrid *dataGrid;
    void PopulateGrid();
//    wxBoxSizer *autoPanelSizer;

  DECLARE_EVENT_TABLE()
};

enum
{
  DATA_FILE_READ = 1500,
  DATA_FILE_WRITE,
  DATA_FILE_TABLE,
  DATA_FILE_CLOSE,
  DATA_EDIT_FIND,
  DATA_EDIT_REPLACE,
  DATA_EDIT_UNDO,
  DATA_EDIT_ADD,
  DATA_EDIT_DEL,
  DATA_EDIT_LOAD,
  DATA_VIEW_REFRESH,
  DATA_VIEW_FIRST,
  DATA_VIEW_LAST,
};

//extern "C" void make_auto (int *w, int *h);
extern "C" char uvar_names[MAXODE][12];
extern "C" int *plotlist, N_plist;
extern "C" int add_stor_col(char *name, char *formula, BROWSER *b);
extern "C" int del_stor_col(char *var, BROWSER *b);
extern "C" void find_value(int col, double val, int *row, BROWSER b);
extern "C" void data_read(char *filename, BROWSER *b);
extern "C" void data_write(char *filename, BROWSER *b);
extern "C" void make_d_table (double xlo, double xhi, int col, char *filename, BROWSER b);
extern "C" void replace_column (char *var, char *form, float **dat, int n);
extern "C" void unreplace_column();
extern "C" void data_get(BROWSER *b);
extern "C" void data_first(BROWSER *b);
extern "C" void data_last(BROWSER *b);

#endif

