/*
xppEditRHSWin_wx.h

Defines the RHS editing window
*/

#ifndef __XPPRHSWINH__
#define __XPPRHSWINH__

#include "Ccode/xpplim.h"

extern "C" int NEQ; /* number of total equations */
extern "C" int NMarkov;
extern "C" int METHOD; /* chosen method */
extern "C" int NODE; /* number of DEs */
extern "C" char uvar_names[MAXODE][12]; /* dep. variable names */
extern "C" char *ode_names[MAXODE]; /* actual equation */
extern "C" int EqType[MAXODE]; /* equation type */
extern "C" int add_expr(char *expr, int *command, int *length);
extern "C" int FIX_VAR;
extern "C" int *my_ode[];

class xppRunWindow;

class xppEditRHSWin : public wxDialog
{
  public:
    xppEditRHSWin(xppRunWindow *p);
    void OnOk(wxCommandEvent &WXUNUSED(event));
    void OnApply(wxCommandEvent &WXUNUSED(event));
    void OnApplyGo(wxCommandEvent &WXUNUSED(event));
    void OnCancel(wxCommandEvent &WXUNUSED(event));
    void OnCloseWindow(wxCloseEvent &WXUNUSED(event));
    void UpdateValues();
    void UpdateDisplay();
  private:
    xppRunWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxTextCtrl **inputs;

    wxButton *okButton;
    wxButton *applyButton;
    wxButton *applyGoButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;
    DECLARE_EVENT_TABLE()
};

enum
{
  RHS_OK = 800,
  RHS_APPLY,
  RHS_APPLY_GO,
  RHS_CANCEL
};

#endif
