/*
xppInitDataWin_wx.h

Defines the window that shows all initial data
*/

#ifndef __XPPINITDATAH__
#define __XPPINITDATAH__

#include "Ccode/xpplim.h"

extern "C" int NODE;
extern "C" int NMarkov;
extern "C" char uvar_names[MAXODE][12]; /* dep. variable names */
extern "C" double last_ic[MAXODE]; /* initial condition values */

class xppRunWindow;

class xppInitDataWin : public wxDialog
{
  public:
    xppInitDataWin(xppRunWindow *p);
    void OnOk(wxCommandEvent &WXUNUSED(event));
    void OnApply(wxCommandEvent &WXUNUSED(event));
    void OnApplyGo(wxCommandEvent &WXUNUSED(event));
    void OnCancel(wxCommandEvent &WXUNUSED(event));
    void OnCloseWindow(wxCloseEvent &WXUNUSED(event));
    void UpdateValues();
    void UpdateDisplay();
  private:
    xppRunWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxTextCtrl **inputs;

    wxButton *okButton;
    wxButton *applyButton;
    wxButton *applyGoButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;

  DECLARE_EVENT_TABLE()
};

enum
{
  INITD_OK = 500,
  INITD_APPLY,
  INITD_APPLY_GO,
  INITD_CANCEL
};

#endif
