/*
xppLogWindow_wx.cpp

Creates a window that catches all of the program messages
*/

#include <wx/wxprec.h>

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#ifndef WX_PRECOMP
  #include <wx/wx.h>
#endif

#include "xppLogWindow_wx.h"

BEGIN_EVENT_TABLE(xppLogWindow, wxFrame)
  EVT_CLOSE(xppLogWindow::OnClose)
END_EVENT_TABLE()

xppLogWindow::xppLogWindow(wxWindow *parent)
  : wxFrame(parent, -1, _T("XPP Log"))
{
  logPanel = new wxPanel(this, -1);
  logText = new wxTextCtrl(logPanel, -1, _T(""), wxDefaultPosition, wxDefaultSize,
                wxTE_MULTILINE | wxTE_READONLY);

  logFrameSizer = new wxBoxSizer(wxVERTICAL);
  logPanelSizer = new wxBoxSizer(wxVERTICAL);
  logTextSizer  = new wxBoxSizer(wxVERTICAL);


  logFrameSizer->SetMinSize(wxSize(400, 500));
  logFrameSizer->Add(logPanelSizer, 1, wxEXPAND);
  logPanelSizer->Add(logTextSizer, 1, wxEXPAND);
  logTextSizer->Add(logText, 1, wxEXPAND); 


  logPanel->SetSizer(logFrameSizer);
  logPanel->SetAutoLayout(TRUE);

  logFrameSizer->Fit(this);
}

void xppLogWindow::LogMessage(wxString &msg)
{
  logText->AppendText(msg);
}

void xppLogWindow::OnClose(wxCloseEvent &event)
{
  Hide();
}
