/*
xppMainWindow_wx.h

Defines xppMainWindow::wxFrame
*/

#ifndef __XPPMAINWINH__
#define __XPPMAINWINH__

class xppCodePanel;
class xppLogWindow;

class xppMainWindow : public wxFrame
{
  public:
    xppMainWindow();
    void OnWindowClose(wxCloseEvent &event);
    void CheckAndExit(wxEvent &event);
    void OnNew(wxCommandEvent &event);
    void OnOpen(wxCommandEvent &event);
    void OnClose(wxCommandEvent &event);
    void OnSave(wxCommandEvent &event);
    void OnSaveAs(wxCommandEvent &event);
    void OnFind(wxCommandEvent &event);
    void OnFindReplace(wxCommandEvent &event);
    void OnExit(wxCommandEvent &event);
    void OnAbout(wxCommandEvent &event);
    void OnShowLog(wxCommandEvent &event);
    void OnSelectAll(wxCommandEvent &event);
    void OnLoad(wxCommandEvent &event);
    void OnRunPlot(wxCommandEvent &event);
    void OnRunBatch(wxCommandEvent &event);
    void OnRunPS(wxCommandEvent &event);
    void OnSetFont(wxCommandEvent &event);

  private:
    void SetWindowTitle(wxString filename);

    wxString newTitle;
    wxString versionString;
    wxString codeFilename;
    wxString codeFullFilename;
    wxAcceleratorEntry accelEntries[1];
    wxAcceleratorTable *accelTable;
    bool haveOpenedFile;
    bool haveSavedFile;

    wxPanel *mainPanel;
    xppCodePanel *mainCode;

    wxBoxSizer *mainFrameSizer;
    wxBoxSizer *mainPanelSizer;

  DECLARE_EVENT_TABLE()
};


enum
{
  XPP_RUN_PLOT = 100,
  XPP_RUN_BATCH,
  XPP_RUN_PS,
  XPP_LOAD,
  XPP_FIND,
  XPP_FIND_REPLACE,
  XPP_SHOW_LOG,
  XPP_SET_FONT
};

extern "C" int ODE_ERROR;
extern "C" int onGo(char *inputFile, char *outputFile, int outputFlag);

#endif
