/*
xppParamsWin_wx.h

Defines the window that shows all initial data
*/

#ifndef __XPPPARAMWINH__
#define __XPPPARAMWINH__

#include "Ccode/xpplim.h"

extern "C" int NUPAR;
extern "C" char upar_names[MAXPAR][11]; /* parameter names */
extern "C" double default_val[MAXPAR]; /*default param values */
extern "C" int set_val(char *name, double value);
extern "C" int get_val(char *name, double *value);

class xppRunWindow;

class xppParamsWin : public wxDialog
{
  public:
    xppParamsWin(xppRunWindow *p);
    void OnOk(wxCommandEvent &WXUNUSED(event));
    void OnApply(wxCommandEvent &WXUNUSED(event));
    void OnApplyGo(wxCommandEvent &WXUNUSED(event));
    void OnDefault(wxCommandEvent &WXUNUSED(event));
    void OnCancel(wxCommandEvent &WXUNUSED(event));
    void OnCloseWindow(wxCloseEvent &WXUNUSED(event));
    void UpdateValues();
    void UpdateDisplay();
  private:
    xppRunWindow *parent;
    wxPanel *panel;

    wxStaticText **labels;
    wxTextCtrl **inputs;

    wxButton *okButton;
    wxButton *applyButton;
    wxButton *applyGoButton;
    wxButton *defaultButton;
    wxButton *cancelButton;

    wxBoxSizer *mainSizer;
    wxBoxSizer *panelSizer;
    wxGridSizer *gridSizer;
    wxBoxSizer *buttonSizer;

  DECLARE_EVENT_TABLE()
};

enum
{
  PARAM_OK = 600,
  PARAM_APPLY,
  PARAM_APPLY_GO,
  PARAM_DEFAULT,
  PARAM_CANCEL
};

#endif
