/*
xppPlotCanvas_wx.h

Defines the plot when the .ode file is run from the main window
*/

#ifndef __XPPPLOTH__
#define __XPPPLOTH__

#include "Ccode/struct.h"
extern GRAPH graph[MAXPOP];

class xppRunWindow;

class xppPlotCanvas : public wxPanel
{
  public:
    xppPlotCanvas() {};
    xppPlotCanvas(wxWindow *parent, xppRunWindow *runPtr, int id);
    wxString getTitle();
    wxFont* GetBigFont();
    wxFont* GetSmallFont();
    wxClientDC* GetDC();
    void Retitle ();
    void SetBigFont(wxFont font);
    void SetSmallFont(wxFont font);
    void OnPaint(wxPaintEvent &event);
    void OnSize(wxSizeEvent &event);
    void OnMouse(wxMouseEvent &event);
    void ZoomFit();
    int GetIndex();
    void UserClicked(int *x, int *y);
    void UserBox(int *x1, int *y1, int *x2, int *y2);
    void SetUserClickMode(int mode);
    void UnsetUserClickMode();
    void DrawPlot(wxDC &dc);
    void DrawBitmap(wxBitmap *bitmap);
  private:
    wxClientDC *plotDC;
    xppRunWindow *runWindow;
    GRAPH *graphPtr;
    wxFont *bigFont;
    wxFont *smallFont;
    int index;

    // mouse values for C functions
    int clickedX;
    int clickedY;
    int boxX1;
    int boxX2;
    int boxY1;
    int boxY2;
    bool gettingUserClick;
    bool gettingUserBox;

    // mouse dragging for 3d
    wxPoint dragStart;
    wxPoint dragChange;
    double theta, phi;

  DECLARE_DYNAMIC_CLASS(xppPlotCanvas)
  DECLARE_EVENT_TABLE()
};

// class for making lists of plots for window management
WX_DECLARE_LIST(xppPlotCanvas, plotList);

extern "C" {
  void redraw_cube(double theta, double phi);
  void re_title();
  void scale_to_real(int i, int j, float *x, float *y);
  void redraw_the_graph();
}

#endif

